<template>
  <v-row justify="center">
    <v-dialog
      v-model="$store.state.application.showSelectNodeDialog"
      max-width="50%"
      persistent
    >
      <v-card>
        <v-card-title v-if="!showNotification"
          >Please select a node to work with
        </v-card-title>
        <v-card-text class="pt-5" v-else>{{ showNotification }}</v-card-text>
        <v-divider></v-divider>
        <v-data-table
          v-if="!showNotification"
          dense
          style="cursor: pointer;"
          hide-default-footer
          :items="nodes"
          single-select
          @click:row="selectNode"
          :headers="[
            {
              text: 'Level',
              align: 'start',
              value: 'level',
              sortable: false,
              divider: 'true',
              width: '25%'
            },
            {
              text: 'Constituency',
              value: 'tenants',
              divider: true,
              width: '25%',
              sortable: false
            },
            {
              text: 'Parent Nodes',
              value: 'parents',
              sortable: false
            }
          ]"
        >
          <template v-slot:[`item.level`]="{ item }">
            <div v-if="item.level === 'portaladmin'">
              <v-tooltip top>
                <template v-slot:activator="{ on, attrs }">
                  <v-icon
                    medium
                    v-on="on"
                    v-bind="attrs"
                    v-if="item.level === 'portaladmin'"
                    >mdi-alpha-p-box-outline
                  </v-icon>
                </template>
                <span>portaladmin</span>
              </v-tooltip>
            </div>
            <div v-if="item.level === 'tenantadmin'">
              <v-tooltip top>
                <template v-slot:activator="{ on, attrs }">
                  <v-icon
                    medium
                    v-on="on"
                    v-bind="attrs"
                    v-if="item.level === 'tenantadmin'"
                    >mdi-alpha-t-box-outline
                  </v-icon>
                </template>
                <span>Tenantadmin</span>
              </v-tooltip>
              {{ item.name }}
            </div>
            <div v-if="item.level === 'orgaadmin'">
              <v-tooltip top>
                <template v-slot:activator="{ on, attrs }">
                  <v-icon
                    medium
                    v-on="on"
                    v-bind="attrs"
                    v-if="item.level === 'orgaadmin'"
                    >mdi-alpha-o-box-outline
                  </v-icon>
                </template>
                <span>Orgaadmin</span>
              </v-tooltip>
              {{ item.name }}
            </div>
          </template>
          <template v-slot:[`item.tenants`]="{ item }">
            <div class="d-flex">
              <UILogo
                class="mx-1"
                v-for="(tenant, i) in item.tenants"
                :key="i"
                v-bind:tenant="tenant.name"
              />
            </div>
          </template>
        </v-data-table>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            :disabled="!$store.state.user.selectedNode.level"
            @click="
              showNotification = '';
              $store.commit('application/setShowSelectNodeDialog', false);
            "
          >
            close
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * * Fadi Abbud <fadi.abbud@intevation.de>
 */
import { useStore } from "@/store";
import { computed, defineAsyncComponent, ref } from "vue";
const UILogo = defineAsyncComponent(() => import("@/components/ui/UILogo.vue"));
const store = useStore();
const nodes = computed(() => {
  let nodes = store.getters["user/getNodes"];
  // Exclude the roles with no defined nodes(organisation/tenant) for tenant/orga-admin
  nodes = nodes.filter(
    n =>
      n.level === "portaladmin" ||
      (["tenantadmin", "orgaadmin"].indexOf(n.level) !== -1 && n.node_id)
  );
  // Display message if there are no active nodes to the logged in user
  if (nodes && !nodes.length) {
    // eslint-disable-next-line vue/no-side-effects-in-computed-properties
    showNotification.value =
      "You do not have any permissions, please get in touch with your contact person.";
  }
  return nodes;
});
const showNotification = ref("");

const selectNode = item => {
  store.commit("user/setSelectedNode", item);
  localStorage.setItem("selectedNode", JSON.stringify(item));
  store.commit("application/setShowSelectNodeDialog", false);
};
</script>
